import java.util.Vector;

/**
 *
 * @author blossier
 */
public class Cadre extends Employe{
    
    private Vector<Employe> subordonnes;
  
    
    /** Constructeur
     * @param nom : nom de l'employe
     * @param genre : genre de l'employe
     */
    public Cadre(String nom, boolean genre) {
	super(nom,genre);
        this.subordonnes = new Vector<Employe>();
        
    }

    /** Constructeur
     * @param nom : nom de l'employe
     * @param genre : genre de l'employe
     * @param superieur : superieur de l'employe
     */
    public Cadre(String nom, boolean genre, Cadre superieur) throws Exception{
        super(nom,genre,superieur);
        this.subordonnes = new Vector<Employe>();
	//superieur.ajouteSubordonne(this);
    }
    
    /**
     * Conversion en string pour l'affichage, cette fonction est appelée 
     * automatiquement lors de la conversion en String
     * @return le nom cadre  précédé de la formule de politesse Mr ou Mme 
     */
    public String toString() {
        if (this.getGenre()==Employe._HOMME) {
            return "Mr "+super.toString();
        } else {
            return "Mme "+super.toString();
        }
    }
    
    
    /**
     * Ajoute un subordonné
     * @parem e:  employe a ajouter
     */
    void ajouteSubordonne(Employe e) throws Exception  {
	if (this.subordonnes.contains(e))  throw new Exception(e+
                " est déjà au service de "+this);
	this.subordonnes.add(e);
    }
    
    /**
     * Affiche sur la sortie standard la liste des subordonnés directs
     */
    public void afficheSubordonnes() {
	System.out.println(this.getNom()+ " a "+ subordonnes.size()+ 
                " subordonnés directs :");
	for (Employe e : this.subordonnes) {
	    System.out.println(e.getNom());
	}
    }
    
    
    /**
     * Calcul le salaire
     * @return le salaire de l'employé
     */
     public double getSalaire() {
	double result =  super.getSalaire();
    	for (Employe e : this.subordonnes) {
	    result = result + 0.4*(e.getSalaire());
	}
	return result;
    }
    
    // Questions facultatives:

   /**
     * Enleve un subordonné
     */
    void enleveSubordonne(Employe e) throws Exception {
	if (!this.subordonnes.contains(e))  throw new Exception(e+
                " n'a pas pour supérieur direct "+ this);
	this.subordonnes.remove(e);
    }
    
    
    

   
    /**
     * Description du service sur la sortie standard
     */
    public void descriptionService() {
	System.out.print("Service de ");
	System.out.println("Ce service est composé de " + afficheService("")+ 
                " personnes.");  
    }

    /**
     * méthode appelée par descriptionService. Elle affiche le service  avec 
     * l'indentation mis en argument et retourne le nombre de personnes 
     * du service
     */
    int afficheService(String ind) {
	int res = super.afficheService(ind);
	if (subordonnes.size()==0) return res;
	if (this.getGenre()==  _HOMME) {
	    System.out.println(ind+" supérieur de :");
	}
	else {
	    System.out.println(ind+" supérieure de :");
	}
	ind = ind+"  ";
	for (Employe e : this.subordonnes) {
	    res = res+e.afficheService(ind);
	}
	return res;
    }
    
    // Méthode utilisée par retireEmploye dans la classe Entreprise
    // Dans le cas d'un cadre on retire également tous ses subordonnées
    void retireDeEntreprise(Entreprise ent){
	super.retireDeEntreprise(ent);
	for  (Employe e : this.subordonnes) {
	    e.retireDeEntreprise(ent);
	}
    }

}
